//=========================================================================
//	fNX [ sceneModel.cpp ]
//	쐬ҁF2017/04/26
//	쐬F
//=========================================================================
//=========================================================================
//	CN[ht@C
//=========================================================================
//#include	"manager.h"
#include	"rendererdx9.h"
#include	"k_tako.h"
//#include	"camera.h"

//=========================================================================
//	萔`
//=========================================================================
#define	TEXTURE_PATH	("data/TEXTURE/")	//eNX`pX

#define MODEL_NAME		( "data/MODEL/octupas.x" )

//=========================================================================
//	RXgN^
//=========================================================================
KTako::KTako()
{
	m_pTextures = NULL;
	m_pMat = NULL;
	m_pMatBuffer = NULL;
	m_pMesh = NULL;
	m_nNumMat = 0;

	SetPosition( D3DXVECTOR3( 0.0f , 50.0f , 0.0f ) );
	SetScale( D3DXVECTOR3( 1.0f , 1.0f , 1.0f ) );
	SetRotate( D3DXVECTOR3( D3DXToRadian( 30.0f ) , D3DXToRadian( 180.0f ) , D3DXToRadian( 20.0f ) ) );

}

//=========================================================================
//	
//=========================================================================
void	KTako::Init(void)
{
	m_pTextures = NULL;
	m_pMat = NULL;
	m_pMatBuffer = NULL;
	m_pMesh = NULL;
	m_nNumMat = 0;

	SetPosition( D3DXVECTOR3( 0.0f , 0.0f , 0.0f ) );
	SetScale( D3DXVECTOR3( 0.05f , 0.05f , 0.05f ) );
	SetRotate( D3DXVECTOR3( 0.0f , 0.0f , 0.0f ) );

	LoadModel( MODEL_NAME );
}

//=========================================================================
//	I
//=========================================================================
void	KTako::Uninit(void)
{
	for( int i = 0 ; i < (int) m_nNumMat ; i++ )
	{
		if( m_pTextures[i] != NULL )
		{
			m_pTextures[i]->Release();
			m_pTextures[i] = NULL;
		}
	}

	if( m_pTextures != NULL )
	{
		delete[] m_pTextures;
		m_pTextures = NULL;
	}
	//[X
	if(m_pMesh != NULL)
	{
		m_pMesh->Release();	
		m_pMesh = NULL;		
	}

	//[X
	if(m_pMatBuffer != NULL)
	{
		m_pMatBuffer->Release();	
		m_pMatBuffer = NULL;	
	}
}

//=========================================================================
// XV
//=========================================================================
void	KTako::Update(void)
{
	
}

//=========================================================================
//`揈
//=========================================================================
void	KTako::Draw(void)
{
	//fǂݍ܂ĂȂ牽Ȃ
	if( m_pMesh == NULL )
	{
		UINT nID = MessageBox( NULL , "fǂݍ܂Ă܂\n" , "ERROR[ sceneModel.cpp ]" , MB_OK | MB_ICONEXCLAMATION );
		return;
	}

	LPDIRECT3DDEVICE9	pDevice;
	pDevice = GetDevice();

	D3DXMATRIX	mtxWorld;	//[h}gNX
	D3DXMatrixIdentity( &mtxWorld );

	//g̏
	D3DXMATRIX	mtxKakudai;	//gs
	D3DXMatrixScaling( &mtxKakudai , GetScale().x , GetScale().y , GetScale().z );

	//]̏
	D3DXMATRIX	mtxKaiten;	//]s
	D3DXMatrixRotationYawPitchRoll( &mtxKaiten , GetRotate().y , GetRotate().x , GetRotate().z );	
	
	D3DXMATRIX	mtxHeikou;	//sړs
	D3DXMatrixTranslation( &mtxHeikou , GetPosition().x , GetPosition().y , GetPosition().z );

	//s̊|Z
	D3DXMatrixMultiply( &mtxWorld , &mtxWorld , &mtxKakudai );	
	D3DXMatrixMultiply( &mtxWorld , &mtxWorld , &mtxKaiten );	
	D3DXMatrixMultiply( &mtxWorld , &mtxWorld , &mtxHeikou );	

	//foCXɃ[hϊso^
	pDevice->SetTransform( D3DTS_WORLD , &mtxWorld );

	//r[s̍쐬
	//D3DXMATRIX	mtxView = CManager::GetCamera()->GetView();

	//foCXɃr[ϊsݒ
	//pDevice->SetTransform( D3DTS_VIEW , &mtxView);

	//݃foCX̐ݒ肳Ă}eA̎擾
	D3DMATERIAL9	matDef;
	pDevice->GetMaterial( &matDef );

	// }eAւ̃|C^擾
	m_pMat = (D3DXMATERIAL*)m_pMatBuffer->GetBufferPointer();


	for( int i = 0 ; i < (int) m_nNumMat ; i++ )
	{

		//foCXɃ}eAݒ
		pDevice->SetMaterial( &m_pMat[i].MatD3D );
	
		//eNX`̐ݒ
		pDevice->SetTexture( 0 , m_pTextures[i] );
		
		//`
		m_pMesh->DrawSubset( i );
	}

	pDevice->SetMaterial( &matDef );
}

//=========================================================================
//	f̓ǂݍ
//=========================================================================
void	KTako::LoadModel( const char* ModelName )
{
	LPDIRECT3DDEVICE9 pDevice;
	pDevice = GetDevice();

	HRESULT hr;	
	hr = D3DXLoadMeshFromX( ModelName , D3DXMESH_MANAGED , pDevice , NULL , &m_pMatBuffer , NULL , &m_nNumMat , &m_pMesh );
	//g̒_HꍇAVXeg	D3DXMESH_SYSTEMMEM
	if( FAILED( hr ) )
	{
		//s
		UINT nID = MessageBox( NULL , "bVf쐬ł܂\n" , "ERROR[ sceneModel.cpp ]" , MB_OK | MB_ICONEXCLAMATION );
		return;
	}


	//}eÃ|C^Ƃăobt@̃AhX擾
	m_pMat = ( D3DXMATERIAL* )m_pMatBuffer->GetBufferPointer();
	m_pTextures	= new LPDIRECT3DTEXTURE9[m_nNumMat];

	for( DWORD i =0; i < m_nNumMat; i++ )
	{
		m_pTextures[ i ] = NULL;

		if( m_pMat[ i ].pTextureFilename )
		{
			char filePath[ MAX_PATH ];
			//strcpy_s( filePath, TEXTURE_PATH );
			strcpy_s( filePath, m_pMat[ i ].pTextureFilename );

			D3DXCreateTextureFromFile( pDevice, filePath, &m_pTextures[ i ] );
		}
	}
}
