/***************************************************************/
//
//
//		System	[ score.h ]
//
//											Author	kazuki tanaka
//											Date	2017 6/27
/*---------------------------------------------------------------
Update : 2017/6/27
			Create Header File -> score.h.h 
 			< Add Class Function >
				SCORE->Constructor
				SCORE->Destructor
				SCORE->Create ( static member )
				SCORE->Init
				SCORE->Uninit
				SCORE->Update
				SCORE->Draw

Update : 2017/6/27



/*-------------------------------------------------------------*/
#ifndef _SCORE_H_

#define _SCORE_H_


/*---------------------------------------------------------------
	Include File
---------------------------------------------------------------*/

#include <vector>
#include "vector3.h"

class Number;

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class Score Using Score
class Score
{
public:
	
	Score( );						// Score Constructor
	~Score( );						// Score Destructor

	static Score* Create( void );	// Score Create Instance Class

	void Init(
		int digit,
		int number  );				// Score Initialize
	void Uninit( void );			// Score Uninitialize
	void Update( void );			// Score Update

	void SetValue( 
		const int value );			// Score SetValue

private:

	// Member Variable
	std::vector<Number*> data;
	Vector3 pos;
	int number;


};


#endif	//	_SCORE_H_


